function [] = Draw_Point_Compare(blues, reds, scale)
%Joshua Stough
%Given two sets of corresponding points, plot the point-wise
%comparisons.  Expecting 2xn

if (nargin < 3), scale = 1; end
%scale is to make the error more visible

figure,axis([0 2560 0 1920]);
%figure, imagesc(I);

if (sum(size(blues) ~= size(reds)) ~= 0)
    error('ERROR: the two point arrays are not the same size.');
end

v = reds - blues;
%vectors from blue to red.
v = scale*v;

line([blues(2,:)' (blues(2,:) + v(2,:))']',[blues(1,:)' (blues(1,:) + v(1,:))']','Marker', '+', 'Color', [1 0 0]);


line([blues(2,:)' blues(2,:)']',[blues(1,:)' blues(1,:)']','Marker', 'o', 'Color', [0 0 1]);

