function [c, a] = Optimize_CA_Param(cp, truepoints, image_size,c, a)
%Joshua Stough
%COMP 290-89, Pollefeys
%Final

%Samples the objective space for a good initialization, performing sort
%of a mean allealing (coarse to fine) sampling for finding the best solution.

global x_world x_image

if (nargin < 5), a = [3.5 6]; end
if (nargin < 4), c = [3.75 7]; end

x_world = truepoints;
x_image = cp;

x0 = zeros(12,1);

x0(1:3) = [0 0 -pi/24]';
%Translation
x0(4:6) = [0 0 0]';

s = image_size;
%image center and axes scale
x0(7:9) = [s(1)/2 s(2)/2 1]';

x0(12) = 6500;


%I'm simply finding the c and a, given all the other settings, that finds
%the most inliers (just the best square_dist). Then resolve the problem 
%using just the best 40 or something, through the objective space again.

bestd = 1e100;

backx0 = x0;

C = c(1):.1:c(2);
for aa = a(1):.1:a(2)
    for cc = C(C > aa & C < (aa + 2))
        x0 = backx0;
        x0(10:11) = [aa cc]';
        
        x = lsqnonlin(@HyperbolicMirrorCost, x0);
        [d,U] = GetHyperbolicResidual(x);
        
        if (sum(d.^2) < bestd)
            bestca = [x(11) x(10)]
            bestd = sum(d.^2);
            bestd
        end
    end
end

disp(sprintf('Lowest sum of square differences: %f', bestd));
disp(sprintf('Best case c, a : %f %f', bestca(1), bestca(2)));

        
       
        