function [] = Optimize_Scale_Param(cp, truepoints, image_size, range)
%Joshua Stough
%COMP290, final

%Optimize over a range of scale parameters in the hyperbolic mirror 
%calibration case.

%The best values obtained in these Optimize functions will go into
%CalibrateHyperbolicMirrorCamera.m

global x_world x_image

if (nargin < 4), range = [5000 7000]; end


x_world = truepoints;
x_image = cp;

x0 = zeros(12,1);

x0(1:3) = [0 0 -pi/24]';
%Translation
x0(4:6) = [0 0 0]';

s = image_size;
%image center and axes scale
x0(7:9) = [s(1)/2 s(2)/2 1]';

x0(10:11) = [3.97223 4.32154]';

bestd = 1e100;
backx0 = x0;
for i = range(1):100:range(2)
    x0 = backx0;
    x0(12) = i;
    
    %d = HyperbolicMirrorCost(x0);
    x = lsqnonlin(@HyperbolicMirrorCost, x0);
    [d,U] = GetHyperbolicResidual(x);
    
    if (sum(d.^2) < bestd)
        besti = i;
        bestd = sum(d.^2);
        bestd
    end
end

disp(sprintf('Lowest sum of square differences: %f', bestd));
disp(sprintf('Best case scale : %f', besti));

%disp('Now run the CalibrateHyperbolicMirrorCamera.m');

%CalibrateHyperbolicMirrorCamera(cp, truepoints, image_size,4, 4.35, besti)
    
    